;                       Desktop Icon Positioner (DIP)

; This program allows you to position the icons on your desktop precisely using
;   the keyboard cursor keys or a mouse.  You may select multiple icons and move
;   them as a unit one pixel at a time, enter an X or Y coordinate for them, or
;   enter a delta to space them out.
;   You may sort on X or Y first to make lining up rows or columns easier.

.686
.model Flat, Stdcall
option Casemap :None   ; case sensitive

.nolist
include Windows.inc

uselib MACRO libname:req
    include    libname.inc
    includelib libname.lib
ENDM

uselib user32
uselib kernel32
uselib shell32
uselib comctl32
uselib comdlg32
uselib gdi32
uselib advapi32 ; just for registry hack
;uselib masm32	; for debug
;uselib debug	; for debug

soff Macro QuotedText:Vararg	; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm

msg Macro qtext:VARARG
pusha
invoke MessageBox,0,soff(qtext),addr ProgName,0
popa
endm

m2m MACRO M1:req, M2:req
	push M2
	pop  M1
ENDM

;  debugging macros
getprtdbuff macro
ifndef prtdBuff
.data?
prtdBuff db 100 dup (?)
.data
idfmt db "%li",0
ilfmt db "%s=%li",0
.code
endif
endm

prtd MACRO argf	;; debugging print integer
getprtdbuff
pusha
mov eax,argf
mov edi,offset prtdBuff
inv wsprintf,addr prtdBuff,addr idfmt,argf
inv MessageBox,hWin,addr prtdBuff,addr ProgName,0
popa
EndM

prtdx MACRO argf,strgadd ;; debugging print integer with string
getprtdbuff
pusha
inv wsprintf,addr prtdBuff,addr ilfmt,strgadd,argf
inv MessageBox,0,addr prtdBuff,0,0
popa
EndM

prtdx2 macro arg
arg2 catstr <">,<arg>,<">
 prtdx arg,soff(arg2)
EndM

.listall

DlgProc Proto :DWord,:DWord,:DWord,:DWord
ChangeP Proto :DWord,:DWord,:DWord

inv equ INVOKE

; dialog controls
Label1    equ 1001
Label2    equ 1002
Label3    equ 1003
Label4    equ 1004
XPos      equ 1021
YPos      equ 1022
DelX      equ 1023
DelY      equ 1024
Caption   equ 1033
DummyT    equ 1034
lv		  equ 1061
Combo	  equ 1062
MoveLeft  equ 2001
MoveUp    equ 2002
MoveRight equ 2003
MoveDown  equ 2004
DoitX     equ 2005
DoitY     equ 2006
DoitDx    equ 2007
DoitDy    equ 2008

; dialog menu items (I always start menu items with zz)
zzMenu   equ 10000
zzFile   equ 10001
	zzFileRestoreFromDefault equ 10011
	zzFileSaveToDefault		 equ 10012 
	zzFileRestoreFromKey	 equ 10013
	zzFileSaveToKey			 equ 10014
	zzFileExit  equ 10019
zzReset  equ 10002
	zzResetSel  equ 10041
	zzResetAll  equ 10042
	zzRefreshLv equ 10044
zzHelp   equ 10003
	zzHelpAbout equ 10101
	zzHelpDip	equ 10102
zzOk     equ 10004
zzCancel equ 10005

MaxName 	equ 225	; maximum text description length for an icon  (actually, its about 212)
MaxTypeSize equ 40	; maximum text length of an icon type (e.g. "Shortcut","File Folder","System Folder", etc.) (actual max unknown)

crlf equ 0dh,0ah
cr	 equ 0dh
lf	 equ 0ah

.data
Marlett     db "Marlett",0 ; The font for the arrow buttons

ProgName    db "Desktop Icon Positioner",0
AboutMsg    db crlf,"Dip version 1.0 by Jim Giordano",0
TmpName     db ".\Dip.tmp",0
IniName db 260 dup (?)

wPosition	db	'[[Dip]]',0	; tag for old window position in ini file
tmpPosition db  '[[Tmp]]',0	; tab for startup positions
DefaultPos	db '[[Def]]',0	; tab for default positions
LineEnd		db	crlf,0

align 4
NT          dd 0           ; NT flag, assume not NT

RunningFlag dd 1  ; am running flag. Set to zero when exit selected
Started     dd 0  ; Program made it through load and is executing
HeapHandle  dd 0  ; Handle to extra memory for arrays and file i/o
HaveData	dd 0  ; Flag that we have desktop data.  Keep original positions on reload of data.

.data?
align 4
hWin        dd ?  ; dialog handle
Buff        db 512 dup (?)  ; short term temp buffer

hFont       dd  ? ; handle of the Marlett font for the button arrows
DSiz        dd  ? ; zero based size of pdat


; PDat structure.  PDat(0) starts at HeapStart
IconPositionData STRUCT     ; format of PDatPos
    PosX dd ?   ; current X position
    PosY dd ?   ; current Y position
    Offt dd ?   ; Offset to start of text in Titles
    Ofty dd ?   ; Offset to type (Type is stored in Titles immediately following Caption)
    Icon dd ?	; icon image info is stored as dword
    Diix dd ? 	; original index into desktop listview
    ODat POINT <>  ; original X and Y position at start of program 
IconPositionData ENDS
PDatSize = 32
PDatShft = 5	; amount to shift to multiply by PDatSize
                ; various methods of accessing the pdat array
                ; set appropriate reg to start of record, I*PDatSize+HeapStart
pdata equ [eax].IconPositionData  ; how to get to data using eax as base register                    
pdatb equ [ebx].IconPositionData  ; to use ebx as the base register
pdatd equ [edx].IconPositionData  ; to use edx as the base register

.data
; Keep these as a group for ShowWindow loop
hLv        dd  lv		; handles for the controls
hCaption   dd  Caption
hXPos      dd  XPos
hYPos      dd  YPos
hDelX      dd  DelX
hDelY      dd  DelY
hDummyT    dd  DummyT
hMoveLeft  dd  MoveLeft
hMoveRight dd  MoveRight
hMoveUp    dd  MoveUp
hMoveDown  dd  MoveDown
               
hLabel1    dd  Label1
hLabel2    dd  Label2
hLabel3    dd  Label3
hLabel4    dd  Label4
hDoitX     dd  DoitX
hDoitY     dd  DoitY
hDoitDx    dd  DoitDx
hDoitDy    dd  DoitDy
EndOfSLoop = $  
               
;  Keep the following out of the ShowWindow loop group above
hCombo     dd  Combo

.data?

hParent    dd ? ; to get desktop listview handle
hListView  dd ? ; desktop listview
hMenu	   dd ?	; the menu
OldEditWnd dd ? ; previous handler for edit controls
hComboEdit dd ? ; edit part of combo box

KeyFlag    dd ?	; for restore-from/save-to non-default key, 1=restore, 2=save

;  our listview data
lvc LV_COLUMN <?>	; column scratch
lvi LV_ITEM   <?>	; item scratch
lvf LV_FINDINFO <?> ; for searching listview
lvRow dd ?

.data

lvflag  dd	0	; flag that we already have an LVN_ITEMCHANGED message

Col0	equ 100	;  width of first column (Caption)
Col1	equ	36	;  width of X col
Col2	equ	36	;  width of Y col
Col3	equ	90	;  width of Type col

ColOrder dd	1,2,0,3 ; To reorganize columns.  First column of listview must be left justified, but we want centered,
					; so we define the third column as the main column, and just move it later. 
SortDirection dd 1  ; sort direction for current column, 1=normal,-1=reversed
LastSortCol	  dd 9	; last column sorted.  If sorting the same one again, change direction of sort. 

.data?
; Vars used for resizing listview and caption
WinPlace  WINDOWPLACEMENT <?>	; size and position of window for next time.  Saved in ini file.
WinRect   RECT <?>  ; left,top,right,bottom of Dialog window
LvRect    RECT <?>  ; delta Listview to Dialog window
LvLeft        dd ?  ; actual Listview left relative to Dialog
LvTop         dd ?  ; actual Listview top relative to Dialog
CaptionTop    dd ?  ; actual Edit control top relative to Dialog
CaptionHeight dd ?
LvDialogWidthDelta  dd ? ; Delta for computing new Listview and Edit control Width
LvDialogHeightDelta dd ? ; Delta for computing new Listview Height

HeapStart dd ?      ; start of extra memory for arrays
TitlesPos dd ?      ; start in Heap of Captions and types for the icons, just past pdat array

FileTemp  dd ?      ; various scratch file info
tmp		  dd ?	    ; short term temp pointers

; Combobox Stuff

COMBOBOXINFO STRUCT
  cbSize            DWORD  ?
  rcItem            RECT  <>
  rcButton          RECT  <>
  stateButton       DWORD  ?
  hwndCombo         DWORD  ?
  hwndItem          DWORD  ?
  hwndList          DWORD  ?
COMBOBOXINFO ENDS

ci COMBOBOXINFO <?>

ComboDat	db  100 dup (?)		; results of using combobox

; showing and hiding menu items stuff for combobox handling

.data?
MenusToHide textequ <0,1,2>

%for MenuNum,<MenusToHide>
	mi&MenuNum& MENUITEMINFO <?>
	mi&MenuNum&Caption db 20 dup (?)
endm
MenusToShow textequ <3,4>
%for MenuNum,<MenusToShow>
	mi&MenuNum& MENUITEMINFO <?>
	mi&MenuNum&Caption db 20 dup (?)
endm


; buffers and handles, etc. for file data reading and writing

.data
Closed equ INVALID_HANDLE_VALUE		; flag we will use to indicate that file is closed (stored in handle)
hIni	dd Closed		; handle to the ini file
hTmp	dd Closed		; handle to temp file
sep		db	'|',0		; separator character

.data?		; vars for file i/o.  See comments at start file file i/o routines
fptr 	dd	?	; next byte to read from file
bptr	dd	?	; pointer into input buffer
bsize	equ	8192	; size of input buffer. If line are > than this then increase ( test with a small number)
bdat	dd  bsize+2 dup (?)	; input buffer
bmax	equ	offset bdat + bsize - 1
blen	dd	?	; number of characters left in input buffer (from bptr to end)
eof		dd	?	; end of file flag.  May still be data in buffer even after eof is reached
eod		dd	?	; end of data flag
ldat	db	2048 dup (?)	; line buffer.  If largest line is > 1024 then increase
llen	dd	?	; number of characters in line
lptr	dd	?	; pointer into line buffer
llast	dd	?	; last valid character in line buffer
sdat	db	500 dup (?)		; one output parameter from Parse. zero byte terminated
slen	dd	?	; length of parsed output parameter
slast	dd	?	; last valid character in sdat
eol		dd	?	; true if end of line reached doing parse
hInst   dd  ?
.code
Program:
    inv InitCommonControls
    inv GetModuleHandle,0
    mov hInst,eax
    inv DialogBoxParam,hInst,101,0,ADDR DlgProc,0
    inv ExitProcess,eax
; -----------------------------------------------------------------------

DlgProc proc uses edi esi ebx hWnd:DWord,uMsg:DWord,wParam:DWord,lParam:DWord
    ; notes to myself as a newbie assembly for windows coder-
 	; windows function will preserve and restore the values of ebx, edi, esi and ebp and we must also.
   	; ecx and edx will not be preserved, eax holds the function return.
    .if uMsg == WM_COMMAND
        ; loword of wparam = menu item, control, or accelerator identifier
        ; hiword of wparam=notification code if from a control, 1 if from accelerator, 0 if from menu
        ; lparam = control sending the message, otherwise 0
        ; if your menu and control ids are unique, no need to see what kind it is.

        mov eax,wParam  ; identifier of the control, or accelerator
        mov edx,eax     ; check hiword (notification code)
        shr edx,16
		.if eax == WM_USER+2	; that's a message I sent to myself to check the listview
            call lvSelChanged
	    .elseif eax==WM_USER+3	; returned focus from elsewhere, check desktop for changes
	    	call CheckForChanges
        .elseif lParam==0   ; menu item or accelerator if zero, else a control
        	; I start all menu items with zz as it groups them together at the end of the list
            .if ax==zzFileExit  ;(hiword of eax is zero since it's from a menu)
            	jmp WrapUp
            .elseif ax==zzFileRestoreFromDefault
                call zzFileRestoreFromDefaultClicked
            .elseif ax==zzFileSaveToDefault
                call zzFileSaveToDefaultClicked
            .elseif ax==zzFileRestoreFromKey
                call zzFileRestoreFromKeyClicked
            .elseif ax==zzFileSaveToKey
                call zzFileSaveToKeyClicked
            .elseif ax==zzResetSel
                call zzResetSelClicked
            .elseif ax==zzResetAll
                call zzResetAllClicked
            .elseif ax==zzRefreshLv
                call zzRefreshLvClick
            .elseif ax==zzHelpAbout
                call zzHelpAboutClicked
            .elseif ax==zzHelpDip
                call zzHelpDipClicked
            .elseif ax==zzOk
            	call zzOkClicked
            .elseif ax==zzCancel
            	call zzCancelClicked
            .endif
        .else   ; a control
            .if ax>=MoveLeft  ; is it a button?  All button ids are 2001 or greater
                .if (dx==BN_CLICKED) || (dx==BN_DBLCLK) ; was a button clicked?
                    .if ax==MoveLeft
                        inv ChangeP,-1,1,XPos	; MoveLeft was Clicked, go do it
                    .elseif ax==MoveUp
                        inv ChangeP,-1,1,YPos	; MoveUp was Clicked
                    .elseif ax==MoveRight
                        inv ChangeP,1,1,XPos	; etc.
                    .elseif ax==MoveDown
                        inv ChangeP,1,1,YPos
                    .elseif ax==DoitX
                        call DoitXClicked
                    .elseif ax==DoitY
                        call DoitYClicked
                    .elseif ax==DoitDx
                        call DoitDxClicked
                    .elseif ax==DoitDy
                        call DoitDyClicked
                    .endif
                    inv SendMessage, lParam, BM_SETSTYLE, BS_PUSHBUTTON, TRUE  ; make button look normal
                    inv SetFocus,hDummyT    ; get the focus off the button
				.endif
            .elseif ax==Caption
                .if dx==EN_SETFOCUS ; get the focus off the caption edit box.
                    inv SetFocus,hDummyT
                .endif
			.elseif ax==Combo
                .if dx==CBN_DBLCLK          ; user double clicked
                    call zzOkClicked
                .endif
            ;.elseif ax==DummyT     ; the only thing we want in DummyT is the cursor keys which are done below
            .endif
        .endif
	.elseif uMsg==WM_NOTIFY		; perhaps something from our listview
		mov edx,lParam
		.if [edx].NMHDR.idFrom==lv
			mov eax,[edx].NMHDR.code		
			.if eax==LVN_COLUMNCLICK	; user wants to sort on this column
				mov eax,[edx].NM_LISTVIEW.iSubItem	; send the column number
				.if eax==LastSortCol
					neg SortDirection		; swap sort direction
				.else
					mov LastSortCol,eax
					mov SortDirection,1
				.endif
				CompareFunc PROTO :DWORD,:DWORD,:DWORD	; tell masm that CompareFunc is a proc (masm is so dumb sometimes)
				inv SendMessage,hLv,LVM_SORTITEMS,eax,addr CompareFunc			
			.elseif eax == LVN_ITEMCHANGED
				.if lvflag==0	; else, already have message posted
					inv PostMessage,hWnd,WM_COMMAND,WM_USER+2,0	; send me a message when settled
					mov lvflag,1	; can send multiple itemchanged messages for one click, only tell me once
				.endif
			.endif
		.endif
    .elseif uMsg== WM_INITDIALOG
        mov eax,hWnd    ; save handle for everyone
        mov hWin,eax
        ; Prevent multiple instances of program
        inv GetWindowText,hWin,addr Buff,100
        inv SetWindowText,hWin,soff("tempx") ; temporarily change it
        inv FindWindow,0,addr Buff
        .if eax
            invoke MessageBox,hWin,soff("Program already loaded."),0,0
            jmp EndIt
        .endif
        inv SetWindowText,hWin,addr Buff
        inv ShowWindow,hWin,0
        call FormLoad
        cmp Started,0  ; test for serious error in setup
        je EndIt
        ; subclass the edit controls so we can see what keys are pressed and act accordingly
		mov ebx,offset hXPos	; handles for edits are grouped together so we can step through them
@@:
		inv SetWindowLong,[ebx],GWL_WNDPROC,EditWndProc
		add ebx,4
		cmp ebx,offset hDummyT
		jbe @b	
		mov OldEditWnd,eax		; save old routine
		
        mov ci.cbSize,sizeof(COMBOBOXINFO)  ; subclass the edit box within the combobox also
        inv GetComboBoxInfo,hCombo,addr ci
        mov eax,ci.hwndItem                 ; want the edit box
        mov hComboEdit,eax                  ; save handle
        inv SetWindowLong,eax,GWL_WNDPROC,EditWndProc
        inv SetFocus,hLv	; default start - select something
    .elseif uMsg == WM_CLOSE
        jmp WrapUp
    .elseif uMsg == WM_SIZE
        call FormResize
	.elseif uMsg==WM_ACTIVATE
		mov eax,wParam
		.if ax==WA_ACTIVE || ax==WA_CLICKACTIVE
			inv PostMessage,hWnd,WM_COMMAND,WM_USER+3,0	; send me a message when everything else is settled
		.endif
    .endif
	xor eax,eax		; return false, tell window to process this message
	jmp DlgProcRet
WrapUp:
    call LockInPositions    
    call zzFileExitClicked
    call FormUnload
EndIt:
    inv EndDialog,hWin,0
DlgProcRet:
	ret
DlgProc Endp

EditWndProc PROC hEdit:DWord,uMsg:DWord,wParam:DWord,lParam:DWord
    ;traps messages to XPos,YPos,DelX,DelY,DummyT and combobox to check keystrokes
	mov edx,hEdit	; who was it?
    mov eax,wParam  ;  and the key pressed
    .if uMsg==WM_KEYDOWN
        .if edx==hDummyT    ; trap arrow keys when in DummyT, means move icon(s) one pixel
            .if al==VK_LEFT
            	mov eax,hMoveLeft
            .elseif al==VK_RIGHT
            	mov eax,hMoveRight
            .elseif al==VK_UP
            	mov eax,hMoveUp
            .elseif al==VK_DOWN
            	mov eax,hMoveDown
            .else
            	jmp @f	; don't want
            .endif
            inv SendMessage,eax,BM_CLICK,0,0
      @@:
			jmp ReturnZero	; discard all others
		.elseif edx==hComboEdit
            .if al==VK_RETURN  ; treat as double click
                call zzOkClicked
                jmp ReturnZero
            .elseif al==VK_ESCAPE  ; user wants to quit
                call zzCancelClicked
                jmp ReturnZero
           .endif
        .endif
    .elseif uMsg==WM_CHAR
        .if edx==hXPos || edx==hYPos || edx==hDelX || edx==hDelY ; check for valid characters 0-9 or minus or backspace
            .if (al>="0" && al<="9") || al=="-" || al==VK_BACK
            	; good, just continue
			.else
				jmp ReturnZero	; no good, mark as we have handled
           .endif
        .elseif edx==hComboEdit
        	mov eax,wParam
            .if al=="[" || al=="]" || al>126 ;illegal
            	jmp ReturnZero
         	.endif
        .endif
   .elseif uMsg == WM_GETDLGCODE
       mov eax,DLGC_WANTALLKEYS    ; need this to get enter key on WM_KEYDOWN
       jmp EditWndProcRet
    .endif
    inv CallWindowProc,OldEditWnd,hEdit,uMsg,wParam,lParam
    jmp EditWndProcRet
ReturnZero:
	xor eax,eax
EditWndProcRet:
	ret
EditWndProc Endp


.data
continueflg   dd 1
Id1Found      dd 0
Id2Found      dd 0
string1wanted db "&Auto Arrange",0   ; menu string to search for
string2wanted db "A&lign to Grid",0   ; menu string to search for
.code

GetMenuStuff proc lmh,rname
    local mcnt,scnt,menuid,sinx    
    inv GetMenuItemCount,lmh
    .if sdword ptr eax>0
        mov mcnt,eax
        push ebx
        mov ebx,0
        .repeat
            inv GetSubMenu,lmh,ebx
            mov scnt,eax
            inv GetMenuItemID,lmh,ebx
            mov menuid,eax
            inv GetMenuString,lmh,ebx,addr Buff,49,MF_BYPOSITION
            .if eax>0
                inv lstrcmp,addr string1wanted,addr Buff
                .if eax==0
                    m2m Id1Found,menuid
                    .if Id2Found
                        mov continueflg,0
                        .break
                    .endif
                .else
                    inv lstrcmp,addr string2wanted,addr Buff
                    .if eax==0
                        m2m Id2Found,menuid
                        .if Id1Found
                            mov continueflg,0
                            .break
                        .endif
                    .endif
                .endif    
            .endif
            .if scnt ; if there was a submenu
                inv GetMenuStuff,scnt,rname
                .break .if continueflg==0
            .endif
            inc ebx
        .until ebx==mcnt
        pop ebx
    .endif
	ret
GetMenuStuff endp

EnumResNameProc proc hand,typ,rname,extra
    local lmh 
    inv LoadMenu,hand,rname
    mov lmh,eax
    inv GetMenuStuff,lmh,rname        
    inv DestroyMenu,lmh
    mov eax,continueflg
	ret
EnumResNameProc endp



FormLoad  proc uses ebx     ; do setup here (get version, setup fonts, get handles, fill listview, etc)

.data?
    OSinfo OSVERSIONINFO <>
	hShell32	 dd ?
	hSysImlSmall dd ?
	hSysImlLarge dd ?
	hProgMan     dd ?
	hSysTray     dd ?
.data
	shell32dll   db "Shell32.DLL",0
	progman	     db "Progman",0
	defview      db "SHELLDLL_defVIEW", 0
	syslistview  db "SysListView32", 0
.code
	; get all the handles of the controls
	mov ebx,offset hLv			; first one of the group
@@:
    invoke GetDlgItem,hWin,[ebx]	; handles start out life equal to the id and are changed here
    mov [ebx],eax
	add ebx,4
	cmp ebx,offset hCombo		; do up through hCombo
	jbe @b


    invoke GetModuleHandle,addr shell32dll	 ;for image stuff
    mov hShell32,eax

    mov OSinfo.dwOSVersionInfoSize,sizeof OSinfo
    inv GetVersionEx,addr OSinfo ; test for NT vs. 95/98
    .if OSinfo.dwPlatformId >= 2
        mov NT,1    ; it's NT
		invoke GetProcAddress,hShell32,660 ; initialize system image list
		.if eax!=0
		    push dword ptr 1
			call eax
		.endif
    .endif

	invoke GetProcAddress,hShell32,71	; get the image lists
	or eax,eax
	jnz @f
	mov eax, offset shell32dll
    jmp ErrorExit
@@:
	push offset hSysImlSmall
	push offset hSysImlLarge
	call eax

	invoke SendMessage,hLv,LVM_SETIMAGELIST,LVSIL_SMALL,hSysImlSmall
	invoke SendMessage,hLv,LVM_SETIMAGELIST,LVSIL_NORMAL,hSysImlLarge  

    inv FindWindow,addr progman,0 ; search for desktop listview
    or  eax,eax
    jnz @f
    mov eax, offset progman 
    jmp ErrorExit
@@:
    mov hProgMan,eax
    inv FindWindowEx,eax, 0,addr defview, 0
    or  eax,eax
    jnz @f
    mov eax,offset defview
    jmp ErrorExit
@@:
    mov hParent,eax
    inv FindWindowEx,eax, 0, addr syslistview, 0
    or  eax,eax
    jne @f
    mov eax,offset syslistview
    jmp ErrorExit
@@:
    mov hListView,eax
    	
	; setup menu item hiding/showing stuff
	inv GetMenu,hWin
	mov hMenu,eax

	%for MenuNum,<MenusToHide,MenusToShow>
        mov mi&MenuNum&.cbSize,sizeof MENUITEMINFO
        mov mi&MenuNum&.cch,20
        mov mi&MenuNum&.fMask,MIIM_ID+MIIM_SUBMENU+MIIM_TYPE+MIIM_DATA
        mov mi&MenuNum&.dwTypeData,offset mi&MenuNum&Caption
        inv GetMenuItemInfo,hMenu,&MenuNum&,TRUE,addr mi&MenuNum&
	endm
	%for MenuNum,<MenusToShow>	; in this case, these are the ones to show when showing the combobox, so remove them for now
		inv RemoveMenu,hMenu,mi&MenuNum&.wID,MF_BYCOMMAND
	endm
	inv DrawMenuBar,hWin


	; Get a font that has arrows for the direction command buttons
    inv CreateFont,-18,0,0,0,0,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH or FF_DONTCARE,addr Marlett
    mov hFont,eax
    ; 2001-2004 are the arrow buttons MoveLeft,MoveUp,MoveRight,MoveDown
    mov ebx,MoveLeft	;2001
@@:
    inv SendDlgItemMessage,hWin,ebx,WM_SETFONT,hFont,TRUE	; set each on to a font with arrows
    inc ebx
    cmp ebx,MoveDown
    jbe @b

    ; save position of listview lv relative to Dialog for resizing event
    inv GetWindowRect,hWin,ADDR WinRect ; get window position
    inv GetWindowRect,hLv,ADDR LvRect   ; get starting position of listview

    ; LvDialogWidthDelta = (LvbRect.right-WinRect.right) - (LvRect.left-WinRect.left)
    ; LvLeft =                                            (LvRect.left-WinRect.left) - 4
    ; LvDialogHeightDelta = (LvRect.bottom-WinRect.bottom)-(LvRect.top-WinRect.top)
    ; LvTop =                                              (LvRect.top-WinRect.top) - 42
    
    mov edx,LvRect.left
    sub edx,WinRect.left
    mov eax,LvRect.right
    sub eax,WinRect.right
    sub eax,edx
    mov LvDialogWidthDelta,eax  ;(will use also for Caption edit box and combo)
    sub edx,4                   ; fudge factor determined by trial and error
    mov LvLeft,edx              ; (will use also for Caption edit box)

    mov edx,LvRect.top
    sub edx,WinRect.top
    mov eax,LvRect.bottom
    sub eax,WinRect.bottom
    sub eax,edx
    mov LvDialogHeightDelta,eax
    sub edx,42              ; fudge factor determined by trial and error
    mov LvTop,edx

    inv GetWindowRect,hCaption,ADDR LvRect   ; get starting position of Caption edit box (use lvRect for scratch)
    mov edx,LvRect.top      ; find top of Caption edit control
    sub edx,WinRect.top
    sub edx,42
    mov CaptionTop,edx
    mov eax,LvRect.bottom
    sub eax,LvRect.top      ; find height of Caption edit control
    mov CaptionHeight,eax
   
    call FmtSetupLv
    mov HaveData,0
    Call GetDesktopIconInfo	; go fill listview

	; GetPathToIni routine
    inv GetModuleFileName,hInst,addr Buff,256    ; get App filename
    inv GetFullPathName,addr Buff,256,offset IniName,addr tmp
    mov esi,tmp	; filename part
    .repeat
    	lodsb
    	.if al==0
    		mov al,"."
    		mov byte ptr[esi-1],al
    	.endif
    .until al=='.'
    mov dword ptr [esi],00696e69h  ; "ini" + terminator

	call OpenIni
	jc	NoDat			; error opening file
	mov ebx,offset wPosition	
	call FindSection
	jc	NoDat			; not found (should never happen unless user manually screwed up ini file)
	call ReadLine		; get the actual positions
	jc	NoDat			; out of data
    ;call ReadWinPlace
	mov ebx,offset WinPlace
	mov ecx,11		; get the 11 items of a WINDOWPLACEMENT
@@:
	call Parse
    jc	NoDat			; bad format or something
	call ReadLong
	mov [ebx],eax
	add ebx,4
	dec	ecx
	jnz @b	
@@:
	inv SetWindowPlacement,hWin,addr WinPlace
	call FormResize		; go resize the listview and combobox    
    inv ShowWindow,hWin,0   ; hide window until rest of tests are done
	
	mov ebx,offset tmpPosition	; save startup condition
	call SaveInfoToIniFile

NoDat:
    call CloseIni		; just in case it's still open

    inc Started   ;All Ok, we have started

    inv SetFocus,hLv    ; select first item in listview
    mov lvi.imask,LVIF_STATE
    mov lvi.stateMask,LVIS_SELECTED or LVIS_FOCUSED
    mov lvi.state,LVIS_SELECTED
    inv SendMessage,hLv,LVM_SETITEMSTATE,0,addr lvi

    call CheckIfMovable
    jnz AllOkay
    inv MessageBox,0,soff ("Unable to move desktop icons. Do you want to try to disable Auto arrange and/or Align to Grid?"),addr ProgName,MB_YESNO or MB_ICONWARNING or MB_ICONWARNING
    cmp eax,IDNO
    jne @f
    ret
@@:
    
.data
hKey   dd 0
dtkey  db "Software\Microsoft\Windows\Shell\Bags\1\Desktop",0
ktype  dd 0
fflags db "FFlags",0
dsize  dd 4     ; size of a dword value
dval   dd 0
sval   dd 0
.code
    ; first change the registry
     inv RegOpenKeyEx,HKEY_CURRENT_USER,addr dtkey,0,KEY_WRITE or KEY_READ,addr hKey
    .if eax == ERROR_SUCCESS
        inv RegQueryValueEx,hKey,addr fflags,0,addr ktype,addr dval,addr dsize
        .if eax == ERROR_SUCCESS
            .if ktype == REG_DWORD	;1111 1111 1111 1111 1110 1111 1111 1010
                and dval,0FFFFEFFAh ; mask off snaptogrid, autoarrange, and noicons
                                    ; see enum for FOLDERFLAGS 
                inv RegSetValueEx,hKey,addr fflags ,0,REG_DWORD,addr dval,dsize
            .endif
        .endif
        inv RegCloseKey,hKey
    .endif
    ; next send the desktop menu commands to disable autoarrange and arrange to grid
    inv EnumResourceNames,hShell32,RT_MENU,addr EnumResNameProc,0  ; go find autoarrange and aligntogrid id
    inv GetWindowLong,hListView,GWL_STYLE
    and eax,LVS_AUTOARRANGE
    cmp eax,LVS_AUTOARRANGE
    jne AutoOkay
    .if Id1Found
        inv SendMessage,hParent,WM_COMMAND,Id1Found,0
        inv SendMessage,hListView,LVM_ARRANGE,0,0
        inv SendMessage,hListView,LVM_UPDATE,0,0
    .else
        jmp UnableToMove
    .endif
AutoOkay:   ; now see if we can move yet. If not, try to disable align to grid.
    call CheckIfMovable
    jnz AllOkay
    .if Id2Found
        inv SendMessage,hParent,WM_COMMAND,Id2Found,0
        call CheckIfMovable
        jnz AllOkay
    .endif
UnableToMove:    
    msg "Still unable to move icons. You must manually disable Auto Arrange and Align to Grid."
    mov Started,0
    ret    
AllOkay:

    ; need to have icons showing (not covered) so we can grab one and move it
    ;   to force desktop to save the changes we made.
    inv FindWindow,soff("Shell_TrayWnd"),0
    mov hSysTray,eax
    invoke SendMessage,hSysTray,WM_COMMAND,19fh,0   ; minimizeall
    ; alternate method would be send Windows+M  using keybd_event  VK_LWIN and VK_M
    call LockInPositions    

    ret
ErrorExit:
    inv MessageBox, 0, eax, soff("Unable to get"),0
    ret
FormLoad Endp    

FormResize proc
local tmpw:DWord

    cmp RunningFlag,1
    jne FormResizeReturn
    inv GetWindowRect,hWin,addr WinRect

    mov eax,WinRect.right
    sub eax,WinRect.left        ;width of dialog
    add eax,LvDialogWidthDelta  ;new width of listview and combo and caption
    mov tmpw,eax                 ;save new width

    mov edx,WinRect.bottom
    sub edx,WinRect.top         ;height of dialog
    add edx,LvDialogHeightDelta ;new height of listview
    inv MoveWindow,hLv,LvLeft,LvTop,eax,edx,TRUE
    inv MoveWindow,hCaption,LvLeft,CaptionTop,tmpw,CaptionHeight,TRUE ;fix width of Caption edit box

    mov edx,WinRect.bottom
    sub edx,WinRect.top         ;height of dialog
	sub edx,48
	inv MoveWindow,hCombo,LvLeft,0,tmpw,edx,TRUE
FormResizeReturn:
    ret
FormResize Endp

FormUnload proc uses ebx
    ;mov Started,0
    mov WinPlace.iLength, sizeof WinPlace
    inv GetWindowPlacement,hWin,addr WinPlace
    call OpenTmp
    jc FormUnloadDone	; error

    ;call WriteWinPlace
	; save the position data to tmp
	mov edi,offset Buff
	invoke WriteFile,hTmp,addr wPosition,7,addr FileTemp,0
	invoke WriteFile,hTmp,addr LineEnd,2,addr FileTemp,0
	mov ebx,offset WinPlace - 4
	mov esi,11		; eleven dwords in WinPlace
@@:
	add ebx,4
	mov eax,[ebx]
	invoke wsprintf,edi,soff("%i|"),eax
	add edi,eax
	dec esi
	jnz @b	

	invoke wsprintf,edi,addr LineEnd
	add eax,edi
	mov [eax],byte ptr 0
	sub eax,offset Buff	; size of output
    inv WriteFile,hTmp,addr Buff,eax,addr FileTemp,0	; always write position as first line, even though it doesn't need to be

    call OpenIni	; copy rest of ini data
    jc FormUnloadExit	; error, may not exist yet

	mov ebx,offset wPosition
	call FindSectionCopy	; copy upto position line
	jc	FormUnloadExit		; out of data

	call DiscardSectionAndCopyRest	; skip data line (and anything else in this section that should not be there)	

FormUnloadExit:	
    call CloseBoth
    invoke DeleteFile,addr IniName
    invoke MoveFile,addr TmpName,addr IniName
FormUnloadDone:
    invoke SendMessage,hSysTray,WM_COMMAND,1a0h,0  ; unminimizeall

    ret
FormUnload Endp

CheckIfMovable proc  ; this routine check to see if icons can be moved
    local canmove,txpos
    mov eax,HeapStart       ; check first item in listview
  	lea eax,pdata.PosX		; position of x coordinate
    mov eax,[eax]           ; value of x
    mov txpos,eax           ; save for checking for change
    add eax,1
    inv ChangeP,eax,0,XPos    ; try to move icon
	Call GetDesktopIconInfo ; get new position if any

    mov eax,HeapStart
  	lea eax,pdata.PosX		
    mov eax,[eax]           ; new value of x
    mov canmove,0
    .if eax!=txpos
        inv ChangeP,txpos,0,XPos    ; put it back
        mov canmove,1
    .endif
	Call GetDesktopIconInfo
	mov eax,canmove
	or eax,eax
	ret
CheckIfMovable endp
LockInPositions proc uses ebx
local txpos,typos,oldpos:POINT
    mov ebx,HeapStart       ; check first item in listview

  	lea eax,pdatb.PosX		; position of x coordinate
    mov eax,[eax]           ; value of x
    mov txpos,eax
    
  	lea eax,pdatb.PosY		; position of y coordinate
    mov eax,[eax]           ; value of y
    mov typos,eax

    inv GetCursorPos,addr oldpos    ; save old position of mouse
    ; now manually emulate the user moving an icon to lock in
    ;  the new positions we set.
    inv SetCursorPos,txpos,typos    ; position cursor over first icon
    inv mouse_event,MOUSEEVENTF_LEFTDOWN,0,0,0,0
    mov edx,100             ; a place to move the icon manually
    .if txpos==edx          ; if already at 100, move elsewhere
        add edx,10
    .endif
    inv SetCursorPos,edx,typos
    inv SetCursorPos,txpos,typos  ; restore
    inv mouse_event,MOUSEEVENTF_LEFTUP,0,0,0,0
    inv SetCursorPos,oldpos.x,oldpos.y  ; restore
    inv Sleep,0    ; give the system a chance to digest all this
	ret
LockInPositions endp

zzFileExitClicked proc      ; cleanup
    inv DeleteObject, hFont
    cmp HeapHandle,0
    je  @f          ; no heap was every allocated
    inv HeapFree, HeapHandle,NULL,HeapStart
@@:
    mov RunningFlag,0

    ret
zzFileExitClicked Endp


GetStrLen proc	; simple slow get the string length.  Enter with address of string in ebx
	mov eax,-1
@@:
	inc eax
	cmp byte ptr[ebx+eax],0
	jne @b
	ret
GetStrLen EndP

.data
IconFlag		db 'Icon',0
.data?
dcnt dd ?
.code

zzFileRestoreFromDefaultClicked proc uses ebx
	mov ebx,offset DefaultPos
	call SetPositionFromFile
	ret
zzFileRestoreFromDefaultClicked EndP

zzOkClicked proc
	mov ebx,offset ComboDat
 	push ebx
	mov [ebx],byte ptr '['
	inc ebx
    inv SendMessage,hCombo,WM_GETTEXT,96,ebx
    push eax	; save length
	call HideCombo
	pop eax
    pop ebx
    cmp eax,0
    je zzOkClickedRet	; no data selected
	add eax,ebx
	inc eax
	mov [eax],word ptr 005Dh	; add terminating "]",0

  	.if KeyFlag==1
		call SetPositionFromFile    ; doing restore
	.else
		call SaveInfoToIniFile		; doing save
	.endif	

zzOkClickedRet:
	ret
zzOkClicked EndP

zzCancelClicked proc
	call HideCombo
	ret
zzCancelClicked EndP

ShowCombo proc uses ebx
	; loop through controls to hide (hLv thru hDoitDy)
	mov ebx,offset hLv
@@:
	inv ShowWindow,[ebx],SW_HIDE
	add ebx,4
	cmp ebx,offset hDoitDy
	jne	@b

	inv ShowWindow,hCombo,SW_SHOW
	
	; fix menu
	%for MenuNum,<MenusToHide>
		inv RemoveMenu,hMenu,mi&MenuNum&.wID,MF_BYCOMMAND
	endm
	%for MenuNum,<MenusToShow>
        inv InsertMenuItem,hMenu,&MenuNum&,TRUE,addr mi&MenuNum&
	endm
    inv DrawMenuBar,hWin
    
	mov ComboDat,0	; preset answer to null string

    call CloseIni
@@:    
    call FindAllSections
    jc ShowComboRet
;	sdat = characters found. zero byte terminated.
;	slen = number of characters found. zero if end of line                        
    mov edx,offset sdat
    cmp word ptr [edx],'[['	; ignore our special keys
    je	@b
    add edx,slen	; skip brackets
    mov [edx-1],byte ptr 0
	inv SendMessage,hCombo,CB_ADDSTRING,0,addr sdat+1
	jmp @b
	     
ShowComboRet:
	ret
ShowCombo EndP

HideCombo proc uses ebx
	inv ShowWindow,hCombo,SW_HIDE

	mov ebx,offset hLv
@@:
	inv ShowWindow,[ebx],SW_SHOW
	add ebx,4
	cmp ebx,offset hDoitDy
	jne	@b

	%for MenuNum,<MenusToHide>
        inv InsertMenuItem,hMenu,&MenuNum&,TRUE,addr mi&MenuNum&
	endm
	%for MenuNum,<MenusToShow>
		inv RemoveMenu,hMenu,mi&MenuNum&.wID,MF_BYCOMMAND
	endm
    inv DrawMenuBar,hWin

    inv SendMessage,hCombo,CB_RESETCONTENT,0,0
    
	ret
HideCombo EndP

.data?
CaptionBuf db 256 dup (?)	; look up actual max of these
TypeBuf	   db 100 dup (?)
OldX	   dd ?
OldY	   dd ?
ix		   dd ?
.code
FindInLV proc CaptionB:dword,TypeB:dword	;Find the item in our listview as defined by the caption in offset CaptionB,
											; and the type as defined by the type in offset TypeB
											; Returns with carry set if not found, carry clear and ebx points to pdata if found,
	mov eax,DSiz
	inc eax
	mov dcnt,eax
	mov	ebx,HeapStart	; pdat start
	mov ix,0
CheckCaptionLoop:
    mov ecx,pdatb.Offt
	inv lstrcmp,ecx,CaptionB
	or eax,eax
	jne CheckCaptionNext		; got it, else fall through

	;CaptionFound, compare type to type
    mov eax,pdatb.Ofty	; start of type
    invoke lstrcmp,eax,TypeB
	or eax,eax
	je FindInLvGood	; not this one

CheckCaptionNext:
    add ebx,PDatSize
	inc ix
    dec dcnt
    jnz CheckCaptionLoop
    stc
    jmp FindInLvRet	; out of data to check

FindInLvGood:	
	clc    
FindInLvRet:
	ret
FindInLV EndP

SetPositionFromFile proc	; expects pointer to section name in ebx
    call OpenIni
    jc SetPositionFromFileError
    call FindSection
    jc SetPositionFromFileError
	mov eax,DSiz
	or	eax,eax
	jz SetPositionFromFileError

NextIcon:	; read each line and match to existing icons
	call ReadLine
	jc	SetPositionFromFileWrap	; out of icons
	call Parse	
	jc NextIcon	; error reading line
	invoke lstrcmp,addr IconFlag,addr sdat	; check for "Icon" as line flag
	or eax,eax
	jnz	SetPositionFromFileWrap	;done, out of icons
	call Parse	; get Caption
	invoke lstrcpy,addr CaptionBuf,addr sdat	; copy caption
	call Parse	; get type
	jc NextIcon
	invoke lstrcpy,addr TypeBuf,addr sdat		; copy type
	call Parse		; get the x value
	jc NextIcon		; no good
	call ReadLong	; convert to binary
	mov OldX,eax	;save xval
	call Parse 		; get the y value
	jc NextIcon		; no good
	call ReadLong
	mov OldY,eax
	
	inv FindInLV, addr CaptionBuf,addr TypeBuf
	jc	 NextIcon	; not found	

	; set icon position
	pusha
	m2m pdatb.PosX,OldX		; save new positions
	m2m pdatb.PosY,OldY
    mov edx,OldY  ; LVM_SETITEMPOSITION wants two words in a DWord
    mov ecx,OldX
    shl edx,16
    mov dx,cx
    mov ebx,ix
    inv SendMessage,hListView,LVM_SETITEMPOSITION,ebx,edx ; ebx=listview index
    popa
    pusha
	; now set text in our listview
	mov lvf.flags,LVFI_PARAM
	mov lvf.lParam,ebx
	invoke SendMessage,hLv,LVM_FINDITEM,-1,addr lvf ; lvf is findinfo structure
	cmp eax,-1
	je	DoNext
	mov lvi.iItem,eax
	call SetPositionInLv
DoNext:
	popa
	jmp NextIcon	; go do next one


SetPositionFromFileError:
	msg "Error restoring positions"	 
SetPositionFromFileWrap:    
    call CloseIni
    call SetEditOfFirstSelected	; restore captions in case first selected was one of the ones that were moved
	ret
SetPositionFromFile EndP

zzFileSaveToDefaultClicked proc uses ebx
	mov ebx,offset DefaultPos
	call SaveInfoToIniFile	
	ret	
zzFileSaveToDefaultClicked EndP 

GetErrDescriptionx proc uses ebx edi Routine:DWORD ; from masm lib, but fixed error and added routine name
LOCAL hLocal:DWORD, Bufferx[256]:BYTE
.data
ErrMsgTmpl 	db '%s: Error Code %i',13,10,'%s',0
Unknown 	db 'UnKnown Error',0
.code
    invoke GetLastError
    mov edi,eax
    invoke FormatMessage,FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM,
                         0,             ; GetItFromSystem
                         edi,0,         ; ErrNum,Default language
                         addr hLocal,   ; where to send the address of string from system
                         0,0            ; any size, no arguments
    mov ebx,offset Unknown
    .if eax!=0
    	invoke LocalLock,hLocal
    	mov ebx,eax
    .endif
    invoke wsprintf,addr Bufferx,offset ErrMsgTmpl,Routine,edi,ebx
    invoke MessageBox,0,addr Bufferx,0,0
    .if ebx!=offset Unknown
    	inv LocalFree,hLocal
	.endif
    ret
GetErrDescriptionx endp

SaveInfoToIniFile proc	; call with pointer to section name (in form of [SectionName],0 ) in ebx
    call OpenTmp
    jnc @f				;ok
    msg "Cannot open scratch file, save aborted." 
    ret					; error, can't save




@@:
    call OpenIni	; copy rest of ini data
    jc @f				; no ini to copy
	call FindSectionCopy	; find section, copy anything found before
@@:
	call GetStrLen	
	inv WriteFile,hTmp,ebx,eax,addr FileTemp,0	; out of old data, write new section
	cmp eax,0
	jne @f
	inv GetErrDescriptionx,soff("Writing default section header")
	ret
@@:
	inv WriteFile,hTmp,addr LineEnd,2,addr FileTemp,0
	or eax,eax
	jnz @f
	ret
@@:
	call SaveDefaultCode	; go write section data
	call DiscardSectionAndCopyRest		; discard previous default values and copy rest of ini to tmp
	
SaveDefaultExit:
	call CloseBoth	; rename tmp to ini
    invoke DeleteFile,addr IniName
    invoke MoveFile,addr TmpName,addr IniName
SaveDefaultDone:
	ret
SaveInfoToIniFile EndP

SaveDefaultCode proc uses ebx
; for i=0 to dsiz
	mov eax,DSiz
	or	eax,eax
	jz	SaveDefaultCodeDone	; no icons to do????
	mov dcnt,eax
	inc dcnt
	mov	ebx,HeapStart	; pdat start
DefaultSaveLoop:
    mov eax,pdatb.Ofty	; compute start of type
    inv wsprintf,addr Buff,soff("%s|%s|%s|%i|%i",crlf),addr IconFlag,pdatb.Offt,eax, pdatb.PosX, pdatb.PosY
    inv WriteFile,hTmp,addr Buff,eax,addr FileTemp,0
    add ebx,PDatSize
    dec dcnt
    jnz DefaultSaveLoop
SaveDefaultCodeDone:

	ret
SaveDefaultCode EndP

zzFileRestoreFromKeyClicked proc	; populate combobox with known sections and get what user wants
	mov KeyFlag,1	; flag doing restore for zzOkClicked routine
	call ShowCombo
    ret
zzFileRestoreFromKeyClicked Endp

zzFileSaveToKeyClicked proc		; show list of known sections and save what user wants
	mov KeyFlag,2	; flag doing save for zzOkClicked routine
	call ShowCombo
	ret
zzFileSaveToKeyClicked Endp


SetEdits proc  ; eax = address in pdat of item in listview (from lparam)
    ; This routine sets the values of X, Y, and Caption in the edit boxes 
    mov edx,pdata.Offt  ; get offset of title
    push eax
    inv SendMessage,hCaption,WM_SETTEXT,0,edx
    pop eax             ; get offset back
    push eax
    inv wsprintf,addr Buff,soff("%i"),pdata.PosX
    inv SendMessage,hXPos,WM_SETTEXT,0,addr Buff
    pop eax
    push eax
    inv wsprintf,addr Buff,soff("%i"),pdata.PosY
    inv SendMessage,hYPos,WM_SETTEXT,0,addr Buff
    pop eax
	ret
SetEdits EndP

GetItemAddress proc	; gets the address within pdata of the item in ecx and puts the result in eax
	push ecx	; save
	mov lvi.iItem,ecx
	mov lvi.imask, LVIF_PARAM
	xor eax,eax
	mov lvi.iSubItem, eax
	inv SendMessage,hLv,LVM_GETITEM,eax,addr lvi	; get the pointer into pdat
	mov eax,lvi.lParam
	pop ecx
	ret
GetItemAddress EndP

DoReset Proc ;call with item number to reset to old position in ecx
	push ebx 
	push ecx
	call GetItemAddress
	mov ebx,eax	; save
    mov edx,pdata.ODat.x
	mov pdata.PosX,edx
    mov edx,pdata.ODat.y
    mov pdata.PosY,edx
    mov lvi.iItem,ecx
	call SetPositionInLv	; go set our listview
	mov eax,ebx
    call SetIconPositionLv	; go set desktop listview
	pop ecx
	pop ebx
    ret
DoReset Endp


zzResetSelClicked proc
    mov ecx,-1     ; do all selected items starting with first
zzResetSelLoop:
    call GetNextSelectedLvItem	; gets index in ecx, pdat ptr in eax
    je  @F      ; all done
    call DoReset
    jmp zzResetSelLoop    ; go back an do rest
@@:
	call SetEditOfFirstSelected
    ret
zzResetSelClicked Endp


zzResetAllClicked proc
	mov ebx,offset tmpPosition	; get startup condition
	call SetPositionFromFile	
	call SetEditOfFirstSelected
    ret
zzResetAllClicked Endp

SetEditOfFirstSelected proc uses ecx eax
	mov ecx,-1
    call GetNextSelectedLvItem
    je  @F      ; all done
    inv SetEdits
@@:
	ret
SetEditOfFirstSelected EndP

zzRefreshLvClick proc
    mov HaveData,0
    Call GetDesktopIconInfo
    ret
zzRefreshLvClick Endp

zzHelpAboutClicked proc
	invoke MessageBox,0,addr AboutMsg,addr ProgName,0
    ret
zzHelpAboutClicked Endp

zzHelpDipClicked proc
	mov eax,0
	inv ShellExecute, eax, eax, soff("Dip.txt"),eax, eax, SW_SHOWNORMAL
    ret
zzHelpDipClicked Endp

GetNextSelectedLvItem proc  ; get the next selected item from the listview, starting with item in ecx,
							; returns new index in ecx, or -1 for not found, eax=pdat pointer to item
	inv SendMessage,hLv,LVM_GETNEXTITEM,ecx,LVNI_SELECTED ; get index of selected item in eax
	mov ecx,eax
    call GetItemAddress
    cmp ecx,-1
    ret
GetNextSelectedLvItem Endp

lvSelChanged proc ; user highlighted or unhighlighted an item, put the position of the first selected item in the edit boxes, etc.

	inv SendMessage,hLv,LVM_GETNEXTITEM,-1,LVNI_SELECTED ; get index of selected item in eax
	mov lvi.iItem,eax
	mov lvi.imask, LVIF_PARAM
	mov lvi.iSubItem, 0
	inv SendMessage,hLv,LVM_GETITEM,eax,addr lvi	; get the pointer into pdat
	mov eax,lvi.lParam
	inv SetEdits	; start of selected parameter
	mov lvflag,0
	
	ret
lvSelChanged EndP

ChangeP proc newx:DWord,IsDelta:DWord,eId:DWord
local OneFound:dword,CurPos:dword	;CurPos=changing delta position to space out icons evenly
    ; change position of selected icons, newx is a delta or absolute postion,
    ; IsDelta tells which, 0=absolute, 1=constant delta, 2=increasing delta (space out icons evenly)
    ; eId is edit control to change, or just used to tell X from Y for type 2.

    mov eax,newx
    cmp IsDelta,0    ; is this a delta or absolute value?
    je  absolute     ; absolute value
    cmp IsDelta,1    ; is it a fixed delta?
    jne VarDelta     ; Vars don't change screen
    inv GetDlgItemInt,hWin,eId,0,TRUE    ; its a delta, get starting x or y value .get info from pdat
    add eax,newx     ; change xpos(or ypos) of current first   e.g. delta + xpos
absolute:
    inv SetDlgItemInt,hWin,eId,eax,TRUE  ; change the one on screen for now
	jmp StartChangePLoop
VarDelta:
	    mov ecx,-1     ; our search index, find first selected
		call GetNextSelectedLvItem	; get first selected which will be start if doing type 2 increasing delta 
	    .if eId==XPos		; save initial position
	        push pdata.PosX  ; Get starting point
	    .else
	        push pdata.PosY  ; Get starting point
	    .endif
	    pop CurPos	; starting point
StartChangePLoop:	;	look for selected icons in listview
	mov ecx,-1    
ChangePLoop:
	call GetNextSelectedLvItem	; get index of item plus pdat ptr in eax
	je ChangePret
    ; now move selected icon
    mov edx,newx				; new value, may be absolute or delta
	push eax					; save pdat base address for SetIconPositionLv below
    .if eId==XPos				; get where to store new position
    	lea eax,pdata.PosX		; where to store new coordinate
    .else
    	lea eax,pdata.PosY
    .endif
    .if IsDelta==0				; move to absolute position
		mov [eax],edx 
;        .if eId==XPos
;            mov pdata.PosX,edx  ; PDat(J).PosX= newx
;        .else
;            mov pdata.PosY,edx  ; PDat(J).PosY= newx
;        .endif
    .elseif IsDelta==1          ; constant delta (e.g. move a group one space right)
		add [eax],edx
;        .if eId==XPos
;            add pdata.PosX,edx  ; PDat(J).PosX=PDat(J).PosX+edx
;        .else
;            add pdata.PosY,edx  ; PDat(J).PosY=PDat(J).PosY+edx
;        .endif
    .else                      ; IsDelta==2   variable delta
        push CurPos             ; get new position
		pop [eax]
;        .if eId==XPos
;            pop pdata.PosX      ; PDat(J).PosX= newx
;        .else
;            pop pdata.PosY      ; PDat(J).PosY= newx
;        .endif
        add CurPos,edx          ; update next position
    .endif
	pop eax						; restore pdat base address
    call SetIconPositionLv    	; ecx is preserved (last found selected item)
NotFound:
	jmp ChangePLoop
ChangePErr:
    msg "err 2"
ChangePret:
    ret

ChangeP Endp

DoitXClicked proc    ; apply values in XPos to icons selected in lv
    inv GetDlgItemInt,hWin,XPos,0,TRUE    ; get new value
    inv ChangeP,eax,0,XPos
    ret
DoitXClicked Endp

DoitYClicked proc    ; apply values in YPos to icons selected in lv
    inv GetDlgItemInt,hWin,YPos,0,TRUE    ; get new value
    inv ChangeP,eax,0,YPos
    ret
DoitYClicked Endp

DoitDxClicked proc    ; apply values in DelX to icons selected in lv
    inv GetDlgItemInt,hWin,DelX,0,TRUE ; get new value
    inv ChangeP,eax,2,XPos             ; ChangeP will test for XPos but not update it for type 2
    ret
DoitDxClicked Endp

DoitDyClicked proc    ; apply values in DelY to icons selected in lv
    inv GetDlgItemInt,hWin,DelY,0,TRUE ; get new value
    inv ChangeP,eax,2,YPos             ; ChangeP will test for YPos but not update it for type 2
    ret
DoitDyClicked Endp

SetIconPositionLv proc uses ebx ecx edx ; assumes eax=pointer into pdat
    mov edx,pdata.PosY  ; LVM_SETITEMPOSITION wants two words in a DWord
    mov ecx,pdata.PosX
    shl edx,16
    mov dx,cx

;  if we were going to save the lParam of the desktop listview and search on it, this is how:
;	push eax
;	mov lvf.flags,LVFI_PARAM
;   mov ebx,pdata.Diix
;	mov lvf.lParam,ebx
;	invoke SendMessage,hListview,LVM_FINDITEM,-1,addr lvf ; lvf is findinfo structure
;	cmp eax,-1
;	je	NotFound
;   inv SendMessage,hListView,LVM_SETITEMPOSITION,eax,edx ; eax=desktop listview index
;	pop ebx

    push eax
    mov ebx,pdata.Diix		; danger, danger, danger.  If something changed the desktop listview order, we are in big trouble..
    inv SendMessage,hListView,LVM_SETITEMPOSITION,ebx,edx ; ebx=listview index
    pop ebx
    
	mov lvi.imask, LVIF_TEXT	; no param for remaining columns
	mov lvi.iSubItem, 1
	mov eax,pdatb.PosX
	call dwtoax
	mov lvi.pszText,offset Buff
	inv SendMessage, hLv, LVM_SETITEM, 0, addr lvi

	mov lvi.iSubItem, 2
	mov eax,pdatb.PosY
	call dwtoax
	mov lvi.pszText,offset Buff
	inv SendMessage, hLv, LVM_SETITEM, 0, addr lvi
	mov eax,ebx
	ret
SetIconPositionLv EndP

GetDesktopIconInfo proc ; get the names and positions of the desktop icons from the desktop listview
Local I:DWord,J:DWord	;   alternately, just update positions from desktop if HaveData <> 0
.data?
pid          dd ?
TitleLength  dd ?
IconCount    dd ?
W            dd ?
PtrT         dd ?
hProcess1    dd ?
hProcess2    dd ?
SharedMem1   dd ?   ; space for LV_ITEM and position data
SharedMem2   dd ?   ; space for caption or title
SharedMem3   dd ?   ; space for the position
FileMapping1 dd ?   
FileMapping2 dd ?
PLen         dd ?
IDL          dd 256 dup (?)
sfi		SHFILEINFO <?>
sztype       db 82 dup (?)
objItem LV_ITEM <?>
objOut  LV_ITEM <?>
d            db  MaxName dup (?)
NewDSiz		 dd ?		; when just updating, don't wipe out DSiz

.code
    inv SendMessage,hListView, LVM_GETITEMCOUNT, 0, 0	; ask the desktop the number of icon present
    mov IconCount,eax
    or  eax,eax
    jz  Done    ; no icons???
    sub eax,1
  	mov NewDSiz,eax
  	.if HaveData==0
    	inv SendMessage,hLv,LVM_DELETEALLITEMS,0,0
    	inv SendMessage,hLv,LVM_SETITEMCOUNT,IconCount,0
    .endif
    
	mov lvRow,0
.data?
TPos    POINT   <>
.code
    ; NT doesn't allow shared memory between two process (ala memory mapped file),
    ; 95/98 doesn't have VirtualAllocEx to allocate memory in another process,
    ; so have to do it two different ways
    mov PLen,sizeof TPos
    inv GetWindowThreadProcessId,hListView,Addr pid
    inv OpenProcess,PROCESS_VM_OPERATION Or PROCESS_VM_READ Or PROCESS_VM_WRITE, 0, pid  ; common usage
    mov hProcess1,eax
    .if NT==1
        inv VirtualAllocEx,eax, 0, sizeof LV_ITEM + sizeof POINT + MaxName, MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE  ; get memory within desktop process
    .else
        ;95/98    we will simply use a memory mapped file
        inv CreateFileMapping,0FFFFFFFFh, 0, PAGE_READWRITE, 0, sizeof LV_ITEM + sizeof POINT + MaxName, 0
        mov FileMapping1,eax
        inv MapViewOfFile,eax, FILE_MAP_ALL_ACCESS, 0, 0, 0
    .endif
    mov SharedMem1,eax          ; save location for LV_ITEM
    add eax,sizeof POINT
    mov SharedMem3,eax
    add eax,sizeof LV_ITEM      
    mov SharedMem2,eax          ; save location of text output

    mov objItem.pszText,eax     ; where we want the text results to go
    mov objItem.cchTextMax,MaxName
    mov objItem.imask,LVIF_TEXT + LVIF_PARAM ; we want a text type item to get title of icon, Param to type to get file info.

    mov eax,IconCount
    shl eax,PDatShft    ; multiply by PDatSize (sizeof IconPositionData) for PDat
    mov PtrT,eax    	; storage needed so far
    mov I,0
    Loop1:      ; get length of all titles to reserve storage space
        .if NT==1
            inv WriteProcessMemory, hProcess1, SharedMem1, ADDR objItem, sizeof LV_ITEM, ADDR W   ;copy LV_ITEM structure to memory
        .else
            inv RtlMoveMemory, SharedMem1, ADDR objItem, sizeof LV_ITEM    ;copy LV_ITEM structure to memory mapped file
        .endif
        inv SendMessage, hListView, LVM_GETITEMTEXT, I, SharedMem1 ; send msg to explorer listview (desktop), ask for title, returns length in eax
        inc eax         ; add one extra for zero-byte terminator
        add PtrT,eax    ; add in length of title to amount needed
        add PtrT,MaxTypeSize     ; additional MaxTypeSize characters for type

        mov eax,NewDSiz    ; zero based so check against IconCount-1
        inc I
        cmp I,eax
        jbe Loop1
    ;Loop1 ends

    ; Get needed Memory
	.if HaveData==0
	    cmp HeapHandle,0
	    je  @f          ; no heap was every allocated
	    inv HeapFree, HeapHandle,NULL,HeapStart  ; clear out old heap
@@:
	    inv GetProcessHeap
	    mov HeapHandle,eax
	    inv HeapAlloc,eax,HEAP_ZERO_MEMORY,PtrT
	    mov HeapStart,eax    ; start of heap and PDat array
	.endif
    ;  get locations of arrays in allocated memory

    mov eax,IconCount
    shl eax,PDatShft     ;skip over pdat array (PDatSize bytes per record)
    add eax,HeapStart
    mov TitlesPos,eax    ;TitlesPos dd ? ; Captions and types for the icons, also denotes end of pdat
    
    mov PtrT,eax  ; offset into Titles
    mov objItem.iSubItem,0
    mov objItem.stateMask,LVIS_SELECTED or LVIS_FOCUSED
    mov I,0     ; loop index
    ;J =  pointer into pdat of current record based upon I (only on first load)
    mov eax,HeapStart
    mov J,eax   ;Save Storage Pointer

    Loop2:      ; time to get the listview data
        mov ecx,I
        mov objItem.iItem,ecx
        inv SendMessage, hListView, LVM_GETITEMPOSITION, I, SharedMem1   ; ask for position of Item I (send msg to explorer listview (desktop))
        .if NT==1
            inv ReadProcessMemory,hProcess1, SharedMem1, addr TPos, PLen, addr W ; read it into TPos
            
            inv WriteProcessMemory, hProcess1, SharedMem1, ADDR objItem, sizeof LV_ITEM, ADDR W   ;copy LV_ITEM structure
            inv SendMessage, hListView, LVM_GETITEM, 0, SharedMem1 ; send msg to explorer listview (desktop), ask for status and lparam
            inv ReadProcessMemory, hProcess1, SharedMem1, addr objOut, sizeof LV_ITEM, ADDR W    ;copy back lv_item
            inv ReadProcessMemory, hProcess1, SharedMem2, addr d, MaxName, ADDR W    ;get Title into d (up to maxname amount)
        .else
            inv RtlMoveMemory, addr TPos, SharedMem1, PLen   ; copy into TPos
            
            inv RtlMoveMemory, SharedMem1, ADDR objItem, sizeof LV_ITEM    ;copy LV_ITEM structure to memory mapped file
            inv SendMessage, hListView, LVM_GETITEM, I, SharedMem1  ;get everything else
            inv RtlMoveMemory, addr objOut, SharedMem1, sizeof LV_ITEM  ; copy back lv_item
            inv RtlMoveMemory, addr d, SharedMem2, MaxName   ; copy Title into d
       .endif
      	inv ReadProcessMemory,hProcess1,objOut.lParam,addr IDL,1024,addr W ; Copy the remote IDL into our local IDL
    	inv SHGetFileInfo,addr IDL,0,addr sfi,SIZEOF SHFILEINFO,SHGFI_SYSICONINDEX+SHGFI_TYPENAME+SHGFI_PIDL+SHGFI_ICON
    	inv lstrcpy,addr sztype,addr sfi.szTypeName

;   pdat  equ  [eax].IconPositionData
		.if HaveData!=0
			; Already have data, search for matching title/type and update new position, etc.
			inv FindInLV, addr d,addr sfi.szTypeName	; search for caption and title in pdat
			jc	DoNext	; no match
			; have match, just move new position and check index number
	        m2m pdatb.PosX,TPos.x
	        m2m pdatb.PosY,TPos.y
			
			mov lvf.flags,LVFI_PARAM
			mov lvf.lParam,ebx
			invoke SendMessage,hLv,LVM_FINDITEM,-1,addr lvf ; lvf is findinfo structure
			cmp eax,-1
			je	DoNext			; didn't find it in our listview?  Really can't happen.
			mov lvi.iItem,eax
			call SetPositionInLv
DoNext:	        
	        inc I
		.else	; new data, save it		
	        mov eax,J           ; store location for this record (pdata start point)
	        mov edx,I
	
	        mov pdata.Diix,edx	; save original desktop listview index
	        mov edx,TPos.x      ; PDat(I).Odat = TPos, PDat(I).PosX=TPos.x etc.,  save current and original positions
	        mov pdata.PosX,edx
	        mov pdata.ODat.x,edx	; original position
	        mov edx,TPos.y
	        mov pdata.PosY,edx
	        mov pdata.ODat.y,edx	; original position
			mov edx,sfi.iIcon
			mov pdata.Icon,edx
	        mov edx,PtrT        ; save location of string in Titles
	        mov pdata.Offt,edx
	        mov eax,offset d    ; source
	        Loop3:
	            mov ch,[eax]    ; move character
	            mov [edx],ch
	            inc edx         ; inc pointers
	            inc eax
	            or ch,ch        ; are we done?
	            jnz Loop3
	        ;Loop3 ends
	        mov PtrT,edx        ; save next store location
	        add PtrT,MaxTypeSize; keep MaxTypeSize characters of type
	        mov eax,J   ;*****        ; get back pdata record location
	        mov pdata.Ofty,edx	; location of type
			inv lstrcpy,edx,addr sztype
	
	        mov eax,J    ;*****       ; store location for this record
	        add J,PDatSize      ; setup next store record, PDatSize bytes/record
	        inc I
	        
			mov ebx,eax
	        call FmtLv
		.endif

CheckDone:        
        mov eax,NewDSiz
        cmp I,eax
        jbe Loop2

	;Loop2 ends

    .if NT==1
        inv VirtualFreeEx, hProcess1, SharedMem1, PLen, MEM_RELEASE
    .else
        inv UnmapViewOfFile, SharedMem1
        inv CloseHandle, FileMapping1
        inv UnmapViewOfFile, SharedMem2
        inv CloseHandle, FileMapping2
    .endif
    inv CloseHandle,hProcess1
Done:
	.if HaveData==0
		m2m DSiz,NewDSiz
		mov HaveData,1
	.endif
	mov	LastSortCol,9	; force normal sort
    ret
GetDesktopIconInfo Endp

CheckForChanges proc
	.if HaveData==1 && Started!=0
		Call GetDesktopIconInfo
	    call SetEditOfFirstSelected	; restore captions in case first selected was one of the ones that were moved
	.endif
	ret
CheckForChanges EndP
FmtSetupLv proc

	mov lvc.imask, LVCF_TEXT + LVCF_WIDTH + LVCF_FMT
	mov lvc.fmt,LVCFMT_LEFT
	mov lvc.pszText, soff("Caption")
	m2m lvc.lx,Col0
	inv SendMessage, hLv, LVM_INSERTCOLUMN, 0, addr lvc

	mov lvc.imask, LVCF_TEXT + LVCF_WIDTH + LVCF_FMT + LVCF_SUBITEM
	mov lvc.pszText, soff("X")
	mov lvc.fmt,LVCFMT_CENTER
	m2m lvc.lx,Col1
	mov lvc.iSubItem, 1
	inv SendMessage, hLv, LVM_INSERTCOLUMN, 1, addr lvc  

	mov lvc.pszText, soff("Y")
	m2m lvc.lx,Col2
	mov lvc.iSubItem, 2
	inv SendMessage, hLv, LVM_INSERTCOLUMN, 2, addr lvc

    inv GetWindowRect,hLv,ADDR LvRect   ; get starting position of listview
	mov eax,LvRect.right
	sub eax,LvRect.left
	
	mov lvc.pszText, soff("Type")
	mov lvc.fmt,LVCFMT_LEFT
	m2m lvc.lx,Col3
	mov lvc.iSubItem, 3
	inv SendMessage, hLv, LVM_INSERTCOLUMN, 3, addr lvc

	mov eax, LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_GRIDLINES or LVS_EX_HEADERDRAGDROP 
	inv SendMessage, hLv, LVM_SETEXTENDEDLISTVIEWSTYLE, eax, eax
	inv SendMessage,hLv,LVM_SETCOLUMNORDERARRAY,4,addr ColOrder

	ret
FmtSetupLv EndP


FmtLv proc ; assumes Row of next item number to insert in lvRow, ebx points to pdat record

	mov lvi.imask, LVIF_TEXT + LVIF_PARAM + LVIF_IMAGE ; set up to save data in listview
	m2m lvi.iItem,lvRow
	mov lvi.iSubItem, 0
	mov edx,pdatb.Offt
	mov lvi.pszText,edx
	mov edx,pdatb.Icon
	mov lvi.iImage,edx
	mov lvi.lParam,ebx	; unique flag=location of data within pdata
	inv SendMessage, hLv, LVM_INSERTITEM, 0, addr lvi

	call SetPositionInLv

	mov lvi.iSubItem, 3
	mov edx,pdatb.Ofty
	mov lvi.pszText,edx
	inv SendMessage, hLv, LVM_SETITEM, 0, addr lvi

	inc lvRow
	ret
FmtLv EndP

SetPositionInLv proc	; sets the item text of the x and y positions to the values in pdatb.  Item number already in lvi.iItem

	mov lvi.imask, LVIF_TEXT	; no param for remaining columns
	mov lvi.iSubItem, 1
	mov eax,pdatb.PosX
	call dwtoax
	mov lvi.pszText,offset Buff
	inv SendMessage, hLv, LVM_SETITEM, 0, addr lvi

	mov lvi.iSubItem, 2
	mov eax,pdatb.PosY
	call dwtoax
	mov lvi.pszText,offset Buff
	inv SendMessage, hLv, LVM_SETITEM, 0, addr lvi

	ret
SetPositionInLv EndP

CompareFunc proc lParam1:DWORD, lParam2:DWORD, SortCol:DWORD  ; compare routine for LVM_SORTITEMS
	push ebx
	mov ebx,lParam1	; to use pdatb
	mov edx,lParam2	; to use pdatd
	.if SortCol==0	; caption
		mov ecx,pdatb.Offt		
		mov eax,pdatd.Offt
		inv lstrcmpi,ecx,eax
	.elseif SortCol==1
		mov eax,pdatb.PosX
		sub eax,pdatd.PosX
	.elseif SortCol==2
		mov eax,pdatb.PosY
		sub eax,pdatd.PosY
	.elseif SortCol==3
		mov ecx,pdatb.Ofty
		mov eax,pdatd.Ofty
		inv lstrcmpi,ecx,eax
	.endif
	cmp	SortDirection,1
	je	@f	; normal
	neg eax		; swap the sort results 
@@:
	pop ebx
	ret	
CompareFunc endp

; ------- file handling procs ----------------------

; These procedures are used to handle the ini and temp file.  They are used rather than the privateprofile
;  functions because the icon name can contain commas and other characters that would foul up the normal
;  privateprofile functions.  Also, I just needed to develop them for other purposes.

; If either of the two files, tmp or ini, are open, the handle is not equal to Closed (InvalidHandle)

;		Parse:
;		  input:
;		  	bptr=starting pointer position in input buffer
;		  output:
;		        bptr advanced past next bar or crlf
;		        sdat=characters found. zero byte terminated.
;		        idat=value of characters found (signed integer only) dw
;		        ilen=number of characters found                        
;		        eof=true if end of buffer reached
;		        eol=true if end of line reached

;    ****** Note;  all of these routines will preserve all registers ********

OpenIni proc ; open the ini file for reading
	pusha		; save all registers the user might want
	call CloseIni	; close it first if it is open
    mov	fptr,0
    mov bptr,bmax
    mov blen,0	; no data in buffer
    inv GetFileAttributes,addr IniName
    cmp eax,0FFFFFFFFh	; does it exist?
    je	OpenIniMissing
	inv CreateFile,addr IniName,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
    cmp eax,INVALID_HANDLE_VALUE
    stc		; assume error
    je OpenIniMissing
OpenIniDone:
    mov hIni,eax	; save handle
    mov eof,0
	clc
OpenIniMissing:
	popa
    ret
OpenIni EndP

OpenTmp proc	; open a scratch file for creating/writing new ini file
	pusha		; save all registers the user might want
	cmp	hTmp,Closed
	je @f
	inv CloseHandle,hTmp
@@:
	inv CreateFile,addr TmpName,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	mov hTmp,eax
    cmp eax,INVALID_HANDLE_VALUE
    clc		; assume ok
    jne @f	; all ok
	inv GetErrDescriptionx,soff("OpenTmp")
	stc		; set error flag
@@:
    popa
    ret
OpenTmp EndP

CloseIni proc
	cmp	hIni,Closed
	je @f	; isn't open, ignore
	pusha
    inv CloseHandle,hIni
    popa
    mov hIni,Closed
@@:
    mov	eof,1
    mov eod,1
	ret
CloseIni EndP

CloseBoth proc		; close tmp and ini if they are open
	call CloseIni
	cmp	hTmp,Closed	; also close the tmp file
	je @f			; isn't open, ignore
	pusha
	inv CloseHandle,hTmp
	popa
	mov hTmp,Closed
@@:
	ret
CloseBoth EndP

FindAllSections proc	; steps through ini, returning next section name found
	;pusha		; we don't use any registers or call any api's, so no need to save
	cmp hIni,Closed
	jne	FindAllSectionsLoop	; ok, file is already open, just find next section
	call OpenIni
	jc FindAllSectionsWrap	; carry already set, go return error
FindAllSectionsLoop:
	call ReadLine
	jc FindAllSectionsWrap	; carry already set, go return error
	call Parse				; ok, have data, will need it if good, so parse it out
	cmp byte ptr sdat,'['	; is it a section?
	jne FindAllSectionsLoop
	clc						; good, all done
FindAllSectionsWrap:
	;popa
	ret
FindAllSections EndP

;.data?
;SectionName db 100 dup (?)
;.code
;
;MakeSectionName proc ; create section name with brackets from string with offset in ebx.  Return with offsetset sectionname in ebx.
;	push ecx
;	mov eax,offset SectionName
;	push eax
;	mov ecx,005D5Bh		; "[]",0  the "]",0 will be saved each time with a new character replacing the "["
;@@:
;	mov [eax],ecx
;	inc eax
;	mov cl,[ebx]
;	inc ebx
;	cmp cl,0
;	jne @b
;@@:
;	pop ebx		; offset SectionName
;	pop ecx
;	ret
;MakeSectionName EndP

FindSectionPlusCopy proc AndCopy:dword	; search for a section within the ini file. Section offset in ebx
	; if AndCopy = 1, copy any lines found from the ini file to the tmp file.

	pusha
	cmp hIni,Closed
	jne	@f			; ok, file is open
	call OpenIni
	jc FindSectionPlusCopyRet	; carry is already set, go exit with error
@@:
	cmp	AndCopy,1
	jne	@f
	cmp hTmp,Closed
	jne @f
	call OpenTmp
@@:
FindSectionLoop:
	call ReadLine
	jc FindSectionPlusCopyRet	; carry is already set, section not found, go exit with error
	call Parse
	invoke lstrcmp,offset sdat,ebx
	or eax,eax		; clears carry flag, so if everything good, just exit
	je	FindSectionPlusCopyRet

	cmp AndCopy,1
	jne FindSectionLoop
	call WriteLine
	jnc FindSectionLoop	; else, carry already set for error flag, just exit
FindSectionPlusCopyRet:
	popa
	ret	; with carry set
	
FindSectionPlusCopy EndP 

FindSection proc	; find the section within the ini file pointed to by ebx
	invoke FindSectionPlusCopy,0
	ret
FindSection EndP

FindSectionCopy proc	; find the section within the ini copying any line previous to the tmp file
	invoke FindSectionPlusCopy,1
	ret
FindSectionCopy EndP

DiscardSectionAndCopyRest proc	; discard all lines until a new section is found
	;	pusha    ; don't use any registers or call any apis, so no save needed
	cmp hIni,Closed
	je DiscardSectionDone
@@:
	call ReadLine
	jc DiscardSectionDone	; out of data
	cmp byte ptr ldat,'['
	jne @b
	call WriteLine			; save section line
	jc DiscardSectionDone

	;Copy Rest Of Ini	
	cmp hTmp,Closed
	je	CopyRestOfIniDone
@@:
	call ReadLine
	jc	CopyRestOfIniDone
	call WriteLine
	jc  CopyRestOfIniDone	; error
	jmp @b
CopyRestOfIniDone:
	call CloseIni

DiscardSectionDone:
	;popa
	ret
DiscardSectionAndCopyRest EndP

ReadBuf proc	; read data from input ini file into input buffer
;	input
;		fptr = next byte to read from file
;	output
;		fptr updated
;		bdat = one buffer full of file data
;		blen = number of characters read into/remaining in buffer
;		bptr = 1  offset into input buffer
;		eof  = true if this routine is called and there is no more data to read

	pusha
	cmp	eof,1
	je	ReadBufDone		; already out of data
	mov edx,offset bdat	; store location
	mov ebx,bsize
	push edx	; save for tests
    inv ReadFile,hIni,edx,ebx,addr FileTemp,0
    pop edx
    or eax,eax
    jnz @f
	inv GetErrDescriptionx,soff("ReadBuf")
    mov blen,0
    stc
    jmp ReadBufRet
@@:	
	mov eax,FileTemp	; number of bytes read
	mov	blen,eax		; save number of bytes read
	or eax,eax
	jnz @f				; no data, must be past end of file
	mov eof,1
	jmp ReadBufDone
@@:
	add edx,eax				; add zerobyte for tests
	mov [edx],byte ptr 0	; make sure it's terminated for tests

	mov bptr,offset bdat	; everything ok, start at beginning of buffer
ReadBufDone:
	clc
ReadBufRet:
	popa
	ret
ReadBuf EndP

ReadLine proc	; copy one line from input buffer into ldat. Discard crlf.
;	input:
;		bptr = offset into input buffer, blen=number of characters available 
;	output:
;		bptr = new pointer into input buffer
;		lptr = offset ldat	; point to first byte of line
;		ldat = line buffer data
;		llen = length of line
;		llast set
;		eod set when readline called with no more data on file or in read buffer

;			also, carryflag set when out of data

local LineDone:BYTE ; flag that we have found carriage return, and if next character is a linefeed, discard it.

	pusha
	mov eod,1		; assume end of data
	mov LineDone,0
	mov	llen,0
	mov edx,offset ldat
	mov lptr,edx
	jmp ReadLineStartLoop	; assume we have data, and go start reading line

ReadLineGetMore:	; out of data in buffer, get more	
	cmp eof,1
	je ReadLineDone	; no more data to read
	call ReadBuf
	jc ReadLineDone		; error

ReadLineStartLoop:
	mov ebx,bptr		; next available input character

ReadLineCheckInput:
	cmp blen,0
	je  ReadLineGetMore	; go get more data

ReadLineGetChar:
	mov eod,0		; found at least one character to process
	mov al,[ebx]	; get character
	cmp LineDone,1	; do we need to discard a linefeed and terminate line?
	jne @f
	cmp	al,lf		; yes, force end of line
	je	ReadLineLineDone	; discard this character and wrap up	
	jmp ReadLineLineDone2	; keep this character and wrap up
@@:
	cmp al,cr		; check for carriage return.  Cr or Lf will terminate line
	jne ReadLineCheckLf
	mov LineDone,1	; Line is done.  If next is linefeed, discard it
	jmp ReadLineNext

ReadLineCheckLf:
	cmp al,lf		; check for line feed
	je	ReadLineLineDone	; end of line

ReadLineSaveChar:
	mov [edx],al	; normal character, save
	mov llast,edx
	inc edx			; set up for next store
	inc llen		; count characters
	mov eol,0		; no longer end of line

ReadLineNext:
	inc ebx
	dec blen
	jmp ReadLineCheckInput	; need more input characters

ReadLineLineDone:
	inc ebx			; skip line terminator
	dec blen
ReadLineLineDone2:
	mov bptr,ebx	; save

ReadLineDone:
	mov [edx],byte ptr 0	; make sure line is terminated
	cmp eod,1	; did we find data?  if eod=0 then carry will be set, 0-1 => carry, we want the opposite
	cmc				; so compliment the carry
	popa
	ret
ReadLine EndP

WriteLine proc	; write the line in the line buffer to the tmp file, plus a crlf
	pusha
	cmp	hTmp,Closed
	je BadWrite
	inv WriteFile,hTmp,addr ldat,llen,addr FileTemp,0
	or eax,eax
	jnz @f
	inv GetErrDescriptionx,soff("WriteLine")
BadWrite:
	stc
	popa
	ret
@@:	
	inv WriteFile,hTmp,addr LineEnd,2,addr FileTemp,0
	clc
	popa
	ret
WriteLine EndP

Parse proc 	; parse one value from the input line into sdat until separator (sep) or end of line
;	input:
;		lptr = offset starting character position (in line buffer)
;	output:
;		lptr advanced past next bar (|) or end of line
;		sdat = characters found. zero byte terminated.
;		slen = number of characters found. zero if end of line                        
;		eol  = true if end of line reached
;		  returns with carry set if there was no data to parse

	pusha
	mov	ebx,offset sdat	; destination
	mov ecx,lptr		; source
	mov slen,0
	cmp ecx,llast
	stc					;assume no data to parse
	ja	ParseExit
@@:
	mov	al,[ecx]
	inc ecx				; set up for next character
	cmp al,sep
	je	ParseDone
	mov [ebx],al
	inc ebx
	inc slen
	cmp ecx,llast
	jbe	@b				; loop
ParseEol:
	mov eol,1
ParseDone:
	mov lptr,ecx
	clc
ParseExit:
	mov [ebx],byte ptr 0
	popa
	ret
Parse EndP

; ---------------  miscellaneous routines -------------------------

dwtoax:				; adapted from what masm32 lib's dwtoa
					; modified to convert what is in eax as input, save to Buff

    or eax,eax		; test for zero and negative values
    jnz @f
    mov word ptr [Buff],30h
	ret
@@:
    push ebx
    push esi
    push edi
    mov edi, offset Buff
    jns pos
    mov byte ptr [edi],'-'
    neg eax
    inc edi
pos:
    mov ecx, 0CCCCCCCDh	; 8 * 1/10
    mov esi, edi	; save start of output for reversing later
@@:
	mov ebx,eax
	mul ecx
	shr edx, 3
	mov eax,edx
	lea edx,[edx*4+edx]
	add edx,edx
	sub ebx,edx
	add bl,'0'
	mov [edi],bl
	add edi, 1
	cmp eax,0
	ja @b

    mov byte ptr [edi], 0       ; terminate the string
    .while (esi < edi)
      sub edi, 1
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      add esi, 1
    .endw
	pop edi
	pop esi
	pop ebx
	ret





;  Adapted from atol in m32lib
ReadLong proc uses ebx ecx edx  ;, AsciiStringIn:DWORD  input is in sdat (result of parse)
; convert ascii string with optional sign as first non-blank character to dword. Stop on invalid character

	xor ebx,ebx			; sign, assume positive
	xor ecx,ecx			; where we will build number
	xor eax,eax
	mov edx,offset sdat
@@:
	mov al,[edx]		; get character to test
	inc edx				; set up for next character
	cmp al,32			; discard leading blanks and tabs
	je @b
	cmp al,9
	je @b
	cmp al,'+'
	je nxt				; ignore
	cmp al,'-'			; check for minus sign
	jne nosign			; wasn't a sign, use this character
	not ebx				; set sign negative
nxt:
	mov al,[edx]
	inc edx
nosign:
	sub al,"0"		
	jc  @F
	cmp al,9
	ja	@f
	lea ecx,[ecx+ecx*4]	; old * 5
	lea ecx,[eax+ecx*2]	; new + old * 10
	jmp nxt
@@:
	mov eax,ecx
	or ebx,ebx			; test sign
	jz @F
	neg eax
@@:
    ret
ReadLong endp


end Program
